#include<stdio.h>
int a[2001],vs[2001],n,m,i,br=1,root=0,rootv;
int main(){


    int a1,b,flag=0;

    scanf("%d",&m);
    for(i=1;i<=m;i++){
      scanf("%d %d",&a1,&b);
      a[b]++;
      int j;
      for(j=1;j<br;j++)
      	if(a1==vs[j])flag=1;
      if(flag==0)vs[br++]=a1;
      flag=0;
      for(j=1;j<br;j++)
      	if(b==vs[j])flag=1;
      if(flag==0)vs[br++]=b;
    }

    int j,max=0;
    for(j=1;j<br;j++){
          if(vs[j]>max)max=vs[j];
    }
    flag=0;
    for(j=1;j<br;j++){
          if(a[vs[j]]>1)flag=1;
          if(a[vs[j]]==0){root++;rootv=vs[j];}
    }

    if ( flag==0 && root==1 )printf("%d %d\n",br-1,rootv);
    else printf("0 0\n");
    return 0;
}
